
class JsonToken {
  static const int PAIR = 0;
  static const int VALUE = 1;
  static const int KEY = 2;
  static const int OBJECTSEPERATOR = 3;
  static const int ARRAYSEPERATOR = 4;
  static const int OBJECTSTART = 5;
  static const int OBJECTEND = 6;
  static const int ARRAYSTART = 7;
  static const int ARRAYEND = 8;
  static const int VALUEPAIR = 9;
  static const int NULL = 9;
  dynamic value;
  int type;
  int index;
  int position;
  int parnterId;
  static Map<int, JsonToken> queue;
  //unclosed objects ids
  static int _osi = 0;
  static List<int> os = new List<int>();
  //unclosed arrays ids
  static int _asi = 0;
  static List<int> als = new List<int>();
  bool closed = false;
  String _key;
  //if this token is apart of a key definition eg."node":{} or "node":[]
  String node;
  static List<JsonToken> partners = new List<JsonToken>();
  static List<JsonToken> parents = new List<JsonToken>();
  static int pos = 0;
  JsonToken parent;
  JsonToken partner;
  JsonToken child;
  static String _path = '/';
  static int _quotes = 0;
  JsonToken(dynamic value, int type, {int position}) {
    this.value = value;
    this.type = type;
    this.position = JsonToken.pos;
    this._key = JsonToken._path.trim();
    JsonToken.pos++;
    //handle : , inside quotes
    if (this.value == '"') {
      JsonToken._quotes++;
    }
    if ((JsonToken._quotes % 2) == 1 &&
        (type == JsonToken.ARRAYSEPERATOR ||
            type == JsonToken.OBJECTSEPERATOR ||
            type == JsonToken.ARRAYSTART ||
            type == JsonToken.ARRAYEND ||
            type == JsonToken.OBJECTSTART ||
            type == JsonToken.OBJECTEND)) {
      this.type = JsonToken.VALUE;
    }

    if (JsonToken.queue != null) {
      JsonToken.queue[(position != null ? position : this.position)] = this;
    } else {
      JsonToken.queue = new Map();
      JsonToken.queue[(position != null ? position : this.position)] = this;
    }
    if (this.type == JsonToken.OBJECTSTART) {
      //partner
      JsonToken._osi++;
      JsonToken.os.add(JsonToken._osi);
      this.parnterId = JsonToken._osi;
      //parent
      var parents = JsonToken.parents;
      if (parents.length > 0) {
        var parent = JsonToken.parents[parents.length - 1];
        this.parent = parent;
        parent.child = this;
      }
      JsonToken.parents.add(this);
    } else if (this.type == JsonToken.OBJECTEND) {
      this.parnterId = JsonToken.os.removeLast();
    } else if (this.type == JsonToken.ARRAYSTART) {
      //partner
      JsonToken._path += '0/';
      JsonToken._asi++;
      JsonToken.als.add(JsonToken._asi);
      this.parnterId = JsonToken._asi;
      //parent
      var parents = JsonToken.parents;
      if (parents.length > 0) {
        var parent = JsonToken.parents[parents.length - 1];
        this.parent = parent;
        parent.child = this;
      }
      JsonToken.parents.add(this);
    } else if (this.type == JsonToken.ARRAYEND) {
      JsonToken._path =
          JsonToken._path.replaceAll(new RegExp(r"[0-9]+\/$"), '');
      this.parnterId = JsonToken.als.removeLast();
    }
    //check for parents
    if (this.type == JsonToken.OBJECTSTART ||
        this.type == JsonToken.ARRAYSTART) {
      //these are parents
      JsonToken.partners.add(this);
    } else if (this.type == JsonToken.OBJECTEND ||
        this.type == JsonToken.ARRAYEND) {
      //these are parent closer
      this.partner = JsonToken.partners.removeLast();
      this.partner.closed = true;
      this.closed = true;
      //remove last parent
      JsonToken.parents.removeLast();
      this.parent = JsonToken.parents.length == 0
          ? null
          : JsonToken.parents[JsonToken.parents.length - 1];
    } else if (this.type == JsonToken.VALUE ||
        this.type == JsonToken.ARRAYSEPERATOR ||
        this.type == JsonToken.OBJECTSEPERATOR ||
        this.type == JsonToken.KEY) {
      //these are values or keys
      this.parent = JsonToken.partners[JsonToken.partners.length - 1];
    }
  }
  JsonToken append(JsonToken token) {
    JsonToken response;
    if (token.type == JsonToken.OBJECTSEPERATOR) {
      this.type = JsonToken.KEY;
    }
    if (this.type == JsonToken.OBJECTSEPERATOR &&
        token.type == JsonToken.VALUE) {
      token.type = JsonToken.VALUEPAIR;
    }
    if (token.type == JsonToken.OBJECTEND || token.type == JsonToken.ARRAYEND) {
      token.closed = true;
    }
    //release a simple token
    if ((token.type == JsonToken.ARRAYSEPERATOR ||
            token.type == JsonToken.ARRAYEND ||
            token.type == JsonToken.OBJECTEND) &&
        this.type == JsonToken.VALUE) {
      //release this token
      this.closed = true;
      //current = new JsonToken(null, JsonToken.VALUE, this.position);
    }
    if (this.type == JsonToken.VALUE &&
        (token.type == JsonToken.VALUE || token.type == JsonToken.KEY)) {
      var r = token;
      this.value += r.value;
      token.value = null;
      response = this;
    } else if (this.type == JsonToken.VALUEPAIR &&
        token.type == JsonToken.VALUE) {
      var r = token;
      this.value += r.value;
      token.value = null;
      response = this;
    } else {
      response = token;
    }
    //update key
    if (this.type == JsonToken.KEY) {
      JsonToken._path +=
          this.value.replaceAll("\"", "").replaceAll("'", "").trim() + "/";
    }
    // or }} or ]}
    if ((this.type == JsonToken.OBJECTEND || this.type == JsonToken.ARRAYEND) &&
        token.type == JsonToken.OBJECTEND) {
      //remove last key
      List<String> pieces = JsonToken._path.split('/');
      pieces.removeLast();
      pieces.removeLast();
      JsonToken._path = pieces.join('/') + '/';
      //update }
      token._key = JsonToken._path.trim();
    }
    //:VALUEPAIR} or :VALUEPAIR,
    if (this.type == JsonToken.VALUEPAIR &&
        (token.type == JsonToken.OBJECTEND ||
            token.type == JsonToken.ARRAYSEPERATOR)) {
      //remove last key
      List<String> pieces = JsonToken._path.split('/');
      pieces.removeLast();
      pieces.removeLast();
      JsonToken._path = pieces.join('/') + '/';
      //update }
      token._key = JsonToken._path.trim();
    }
    //also remove key for {}, and 0 parent is {
    if (this.type == JsonToken.OBJECTEND &&
        token.type == JsonToken.ARRAYSEPERATOR) {
      if (this.parent != null) {
        if (this.parent.type == JsonToken.OBJECTSTART) {
          //remove last key
          List<String> pieces = JsonToken._path.split('/');
          pieces.removeLast();
          pieces.removeLast();
          JsonToken._path = pieces.join('/') + '/';
        }
      }
    }

    //also remove key for {}, or { }} with this.parent.type = {

    //[{},{}] or [a,b,c,d,e,f] or [[a,b,c],[a,b,c]]
    if ((this.type == JsonToken.VALUE ||
            this.type == JsonToken.OBJECTEND ||
            this.type == JsonToken.ARRAYEND) &&
        token.type == JsonToken.ARRAYSEPERATOR) {
      if (this.parent != null) {
        if (this.parent.type == JsonToken.ARRAYSTART) {
          int lastIndex = int.parse(
              new RegExp(r"([0-9]+)\/$").firstMatch(JsonToken._path).group(1));
          JsonToken._path = JsonToken._path.replaceAll(
              new RegExp(r"([0-9]+)\/$"), (lastIndex + 1).toString() + '/');
        }
      }
    }
    return response;
  }

  get key {
    return this._key;
  }

  toString() {
    return this.value;
  }

  static int getType(String value) {
    if (value == null) {
      return JsonToken.NULL;
    } else if (value == ']') {
      return JsonToken.ARRAYEND;
    } else if (value == '[') {
      return JsonToken.ARRAYSTART;
    } else if (value == '{') {
      return JsonToken.OBJECTSTART;
    } else if (value == '}') {
      return JsonToken.OBJECTEND;
    } else if (value == ',') {
      return JsonToken.ARRAYSEPERATOR;
    } else if (value == ':') {
      return JsonToken.OBJECTSEPERATOR;
    } else {
      return JsonToken.VALUE;
    }
  }
}
