library rbtree;
import 'dart:async';

import 'JsonToken.dart';
import 'Streamer.dart';

class JsonTokenizer {
  Streamer stream;
  JsonToken token;
  StreamController<int> _sc;
  JsonTokenizer(Streamer stream) {
    this.stream = stream;
    this._sc = new StreamController<int>();
    this.token = new JsonToken(null, JsonToken.NULL, position: 0);
  }
  Stream<int> get tokenize {
    Stream<String> streamer = this.stream.start;
    streamer.listen((String response) {
      response = this.tidy(response);
      response.split("").forEach((String rawToken) {
        JsonToken other = new JsonToken(rawToken, JsonToken.getType(rawToken));
        this.token = this.token =
            (this.token != null ? this.token : JsonToken.queue.values.last)
                .append(other);
      });
      this.destroy();
      this._sc.add(1);
    }, onDone: () {
      _sc.close();
    }, onError: (error) {
      _sc.addError(error);
    });
    return _sc.stream;
  }

  //remove completed items
  destroy() {
    List deletables = new List();
    JsonToken.queue.forEach((int key, JsonToken value) {
      if (value.value == null) {
        deletables.add(key);
      }
    });
    deletables.forEach((v) {
      if (JsonToken.queue.containsKey(v)) {
        JsonToken.queue.remove(v);
      }
    });
    //delete sendables
  }

  String tidy(String sequence) {
    return sequence
        .replaceAll(new RegExp(r"(\s+|)\{(\s+|)"), '{')
        .replaceAll(new RegExp(r"(\s+|)\:(\s+|)"), ':')
        .replaceAll(new RegExp(r"(\s+|),(\s+|)"), ',')
        .replaceAll(new RegExp(r"(\s+|)\}(\s+|)"), '}')
        .replaceAll(new RegExp(r"(\s+|)\[(\s+|)"), '[')
        .replaceAll(new RegExp(r"(\s+|)\](\s+|)"), ']')
        .replaceAll(new RegExp(r"[\r\n\t]+(.+[\r\n\t]+.+)[\t\r\n]+"), '');
  }
}
